javax.ws.rs.core

## Class UriBuilder

- java.lang.Object
- - javax.ws.rs.core.UriBuilder

-     public abstract class UriBuilder
      extends Object

  URI template-aware utility class for building URIs from their components. See `Path.value()` for an explanation of URI templates.

  Builder methods perform contextual encoding of characters not permitted in the corresponding URI component following the rules of the application/x-www-form-urlencoded media type for query parameters and RFC 3986 for all other components. Note that only characters not permitted in a particular component are subject to encoding so, e.g., a path supplied to one of the `path` methods may contain matrix parameters or multiple path segments since the separators are legal characters and will not be encoded. Percent encoded values are also recognized where allowed and will not be double encoded.

  URI templates are allowed in most components of a URI but their value is restricted to a particular component. E.g.

  > `UriBuilder.fromPath("{arg1}").build("foo#bar");`

  would result in encoding of the '#' such that the resulting URI is "foo%23bar". To create a URI "foo#bar" use

  > `UriBuilder.fromPath("{arg1}").fragment("{arg2}").build("foo", "bar")`

  instead. URI template names and delimiters are never encoded but their values are encoded when a URI is built. Template parameter regular expressions are ignored when building a URI, i.e. no validation is performed.
  Since:
    1.0
  Author:
    Paul Sandoz, Marc Hadley
  See Also:
    `URI`, `Path`

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `UriBuilder()` Protected constructor, use one of the static `fromXxx(...)` methods to obtain an instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract URI` | `build(Object... values)` Build a URI, using the supplied values in order to replace any URI template parameters.
    `abstract URI` | `build(Object[] values, boolean encodeSlashInPath)` Build a URI, using the supplied values in order to replace any URI template parameters.
    `abstract URI` | `buildFromEncoded(Object... values)` Build a URI.
    `abstract URI` | `buildFromEncodedMap(Map<String,?> values)` Build a URI.
    `abstract URI` | `buildFromMap(Map<String,?> values)` Build a URI.
    `abstract URI` | `buildFromMap(Map<String,?> values, boolean encodeSlashInPath)` Build a URI.
    `abstract UriBuilder` | `clone()` Create a copy of the UriBuilder preserving its state.
    `abstract UriBuilder` | `fragment(String fragment)` Set the URI fragment.
    `static UriBuilder` | `fromLink(Link link)` Create a new instance initialized from a Link.
    `static UriBuilder` | `fromMethod(Class<?> resource, String method)` Create a new instance representing a relative URI initialized from a `Path`-annotated method.
    `static UriBuilder` | `fromPath(String path)` Create a new instance representing a relative URI initialized from a URI path.
    `static UriBuilder` | `fromResource(Class<?> resource)` Create a new instance representing a relative URI initialized from a root resource class.
    `static UriBuilder` | `fromUri(String uriTemplate)` Create a new instance initialized from an existing URI.
    `static UriBuilder` | `fromUri(URI uri)` Create a new instance initialized from an existing URI.
    `abstract UriBuilder` | `host(String host)` Set the URI host.
    `abstract UriBuilder` | `matrixParam(String name, Object... values)` Append a matrix parameter to the existing set of matrix parameters of the current final segment of the URI path.
    `protected static UriBuilder` | `newInstance()` Creates a new instance of UriBuilder.
    `abstract UriBuilder` | `path(Class resource)` Append the path from a Path-annotated class to the existing path.
    `abstract UriBuilder` | `path(Class resource, String method)` Append the path from a Path-annotated method to the existing path.
    `abstract UriBuilder` | `path(Method method)` Append the path from a `Path`-annotated method to the existing path.
    `abstract UriBuilder` | `path(String path)` Append path to the existing path.
    `abstract UriBuilder` | `port(int port)` Set the URI port.
    `abstract UriBuilder` | `queryParam(String name, Object... values)` Append a query parameter to the existing set of query parameters.
    `abstract UriBuilder` | `replaceMatrix(String matrix)` Set the matrix parameters of the current final segment of the current URI path.
    `abstract UriBuilder` | `replaceMatrixParam(String name, Object... values)` Replace the existing value(s) of a matrix parameter on the current final segment of the URI path.
    `abstract UriBuilder` | `replacePath(String path)` Set the URI path.
    `abstract UriBuilder` | `replaceQuery(String query)` Set the URI query string.
    `abstract UriBuilder` | `replaceQueryParam(String name, Object... values)` Replace the existing value(s) of a query parameter.
    `abstract UriBuilder` | `resolveTemplate(String name, Object value)` Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied value.
    `abstract UriBuilder` | `resolveTemplate(String name, Object value, boolean encodeSlashInPath)` Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied value.
    `abstract UriBuilder` | `resolveTemplateFromEncoded(String name, Object value)` Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied encoded value.
    `abstract UriBuilder` | `resolveTemplates(Map<String,Object> templateValues)` Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs.
    `abstract UriBuilder` | `resolveTemplates(Map<String,Object> templateValues, boolean encodeSlashInPath)` Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs.
    `abstract UriBuilder` | `resolveTemplatesFromEncoded(Map<String,Object> templateValues)` Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs.
    `abstract UriBuilder` | `scheme(String scheme)` Set the URI scheme.
    `abstract UriBuilder` | `schemeSpecificPart(String ssp)` Set the URI scheme-specific-part (see `URI`).
    `abstract UriBuilder` | `segment(String... segments)` Append path segments to the existing path.
    `abstract String` | `toTemplate()` Get the URI template string represented by this URI builder.
    `abstract UriBuilder` | `uri(String uriTemplate)` Parses the `uriTemplate` string and copies the parsed components of the supplied URI to the UriBuilder replacing any existing values for those components.
    `abstract UriBuilder` | `uri(URI uri)` Copies the non-null components of the supplied URI to the UriBuilder replacing any existing values for those components.
    `abstract UriBuilder` | `userInfo(String ui)` Set the URI user-info.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### UriBuilder

          protected UriBuilder()

      Protected constructor, use one of the static `fromXxx(...)` methods to obtain an instance.

  - ### Method Detail

    - #### newInstance

          protected static UriBuilder newInstance()

      Creates a new instance of UriBuilder.
      Returns:
        a new instance of UriBuilder.

    - #### fromUri

          public static UriBuilder fromUri(URI uri)

      Create a new instance initialized from an existing URI.
      Parameters:
        `uri` - a URI that will be used to initialize the UriBuilder.
      Returns:
        a new UriBuilder.
      Throws:
        `IllegalArgumentException` - if uri is `null`.

    - #### fromUri

          public static UriBuilder fromUri(String uriTemplate)

      Create a new instance initialized from an existing URI.
      Parameters:
        `uriTemplate` - a URI template that will be used to initialize the UriBuilder, may contain URI parameters.
      Returns:
        a new UriBuilder.
      Throws:
        `IllegalArgumentException` - if `uriTemplate` is not a valid URI template or is `null`.

    - #### fromLink

          public static UriBuilder fromLink(Link link)

      Create a new instance initialized from a Link.
      Parameters:
        `link` - a Link that will be used to initialize the UriBuilder, only its URI is used.
      Returns:
        a new UriBuilder
      Throws:
        `IllegalArgumentException` - if link is `null`
      Since:
        2.0

    - #### fromPath

          public static UriBuilder fromPath(String path)
                                     throws IllegalArgumentException

      Create a new instance representing a relative URI initialized from a URI path.
      Parameters:
        `path` - a URI path that will be used to initialize the UriBuilder, may contain URI template parameters.
      Returns:
        a new UriBuilder.
      Throws:
        `IllegalArgumentException` - if path is `null`.

    - #### fromResource

          public static UriBuilder fromResource(Class<?> resource)

      Create a new instance representing a relative URI initialized from a root resource class.
      Parameters:
        `resource` - a root resource whose `Path` value will be used to initialize the UriBuilder.
      Returns:
        a new UriBuilder.
      Throws:
        `IllegalArgumentException` - if resource is not annotated with `Path` or resource is `null`.

    - #### fromMethod

          public static UriBuilder fromMethod(Class<?> resource,
                              String method)

      Create a new instance representing a relative URI initialized from a `Path`-annotated method. This method can only be used in cases where there is a single method with the specified name that is annotated with `Path`.
      Parameters:
        `resource` - the resource containing the method.
        `method` - the name of the method whose `Path` value will be used to obtain the path to append.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if resource or method is `null`, or there is more than or less than one variant of the method annotated with `Path`.
      Since:
        2.0

    - #### clone

          public abstract UriBuilder clone()

      Create a copy of the UriBuilder preserving its state. This is a more efficient means of creating a copy than constructing a new UriBuilder from a URI returned by the `build(Object...)` method.
      Overrides:
        `clone` in class `Object`
      Returns:
        a copy of the UriBuilder.

    - #### uri

          public abstract UriBuilder uri(URI uri)

      Copies the non-null components of the supplied URI to the UriBuilder replacing any existing values for those components.
      Parameters:
        `uri` - the URI to copy components from.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the `uri` parameter is `null`.

    - #### uri

          public abstract UriBuilder uri(String uriTemplate)

      Parses the `uriTemplate` string and copies the parsed components of the supplied URI to the UriBuilder replacing any existing values for those components.
      Parameters:
        `uriTemplate` - a URI template that will be used to initialize the UriBuilder, may contain URI parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if `uriTemplate` is not a valid URI template or is `null`.
      Since:
        2.0

    - #### scheme

          public abstract UriBuilder scheme(String scheme)

      Set the URI scheme.
      Parameters:
        `scheme` - the URI scheme, may contain URI template parameters. A `null` value will unset the URI scheme, but will not unset the any scheme-specific-part components.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if scheme is invalid.

    - #### schemeSpecificPart

          public abstract UriBuilder schemeSpecificPart(String ssp)

      Set the URI scheme-specific-part (see `URI`). This method will overwrite any existing values for authority, user-info, host, port and path.
      Parameters:
        `ssp` - the URI scheme-specific-part, may contain URI template parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if ssp cannot be parsed or is `null`.

    - #### userInfo

          public abstract UriBuilder userInfo(String ui)

      Set the URI user-info.
      Parameters:
        `ui` - the URI user-info, may contain URI template parameters. A `null` value will unset userInfo component of the URI.
      Returns:
        the updated UriBuilder.

    - #### host

          public abstract UriBuilder host(String host)

      Set the URI host.
      Parameters:
        `host` - the URI host, may contain URI template parameters. A `null` value will unset the host component of the URI, but will not unset other authority component parts (`user info` or `port`).
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if host is invalid.

    - #### port

          public abstract UriBuilder port(int port)

      Set the URI port.
      Parameters:
        `port` - the URI port, a value of -1 will unset an explicit port.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if port is invalid.

    - #### replacePath

          public abstract UriBuilder replacePath(String path)

      Set the URI path. This method will overwrite any existing path and associated matrix parameters. Existing '/' characters are preserved thus a single value can represent multiple URI path segments.
      Parameters:
        `path` - the path, may contain URI template parameters. A `null` value will unset the path component of the URI.
      Returns:
        the updated UriBuilder.

    - #### path

          public abstract UriBuilder path(String path)

      Append path to the existing path. When constructing the final path, a '/' separator will be inserted between the existing path and the supplied path if necessary. Existing '/' characters are preserved thus a single value can represent multiple URI path segments.
      Parameters:
        `path` - the path, may contain URI template parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if path is `null`.

    - #### path

          public abstract UriBuilder path(Class resource)

      Append the path from a Path-annotated class to the existing path. When constructing the final path, a '/' separator will be inserted between the existing path and the supplied path if necessary.
      Parameters:
        `resource` - a resource whose `Path` value will be used to obtain the path to append.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if resource is `null`, or if resource is not annotated with `Path`.

    - #### path

          public abstract UriBuilder path(Class resource,
                        String method)

      Append the path from a Path-annotated method to the existing path. When constructing the final path, a '/' separator will be inserted between the existing path and the supplied path if necessary. This method is a convenience shortcut to `path(Method)`, it can only be used in cases where there is a single method with the specified name that is annotated with `Path`.
      Parameters:
        `resource` - the resource containing the method.
        `method` - the name of the method whose `Path` value will be used to obtain the path to append.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if resource or method is `null`, or there is more than or less than one variant of the method annotated with `Path`.

    - #### path

          public abstract UriBuilder path(Method method)

      Append the path from a `Path`-annotated method to the existing path. When constructing the final path, a '/' separator will be inserted between the existing path and the supplied path if necessary.
      Parameters:
        `method` - a method whose `Path` value will be used to obtain the path to append to the existing path.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if method is `null` or is not annotated with a `Path`.

    - #### segment

          public abstract UriBuilder segment(String... segments)

      Append path segments to the existing path. When constructing the final path, a '/' separator will be inserted between the existing path and the first path segment if necessary and each supplied segment will also be separated by '/'. Existing '/' characters are encoded thus a single value can only represent a single URI path segment.
      Parameters:
        `segments` - the path segment values, each may contain URI template parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if segments or any element of segments is `null`.

    - #### replaceMatrix

          public abstract UriBuilder replaceMatrix(String matrix)

      Set the matrix parameters of the current final segment of the current URI path. This method will overwrite any existing matrix parameters on the current final segment of the current URI path. Note that the matrix parameters are tied to a particular path segment; subsequent addition of path segments will not affect their position in the URI path.
      Parameters:
        `matrix` - the matrix parameters, may contain URI template parameters. A `null` value will remove all matrix parameters of the current final segment of the current URI path.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if matrix cannot be parsed.
      See Also:
        Matrix URIs

    - #### matrixParam

          public abstract UriBuilder matrixParam(String name,
                               Object... values)

      Append a matrix parameter to the existing set of matrix parameters of the current final segment of the URI path. If multiple values are supplied the parameter will be added once per value. Note that the matrix parameters are tied to a particular path segment; subsequent addition of path segments will not affect their position in the URI path.
      Parameters:
        `name` - the matrix parameter name, may contain URI template parameters.
        `values` - the matrix parameter value(s), each object will be converted. to a `String` using its `toString()` method. Stringified values may contain URI template parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if name or values is `null`.
      See Also:
        Matrix URIs

    - #### replaceMatrixParam

          public abstract UriBuilder replaceMatrixParam(String name,
                                      Object... values)

      Replace the existing value(s) of a matrix parameter on the current final segment of the URI path. If multiple values are supplied the parameter will be added once per value. Note that the matrix parameters are tied to a particular path segment; subsequent addition of path segments will not affect their position in the URI path.
      Parameters:
        `name` - the matrix parameter name, may contain URI template parameters.
        `values` - the matrix parameter value(s), each object will be converted. to a `String` using its `toString()` method. Stringified values may contain URI template parameters. If `values` is empty or `null` then all current values of the parameter are removed.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if name is `null`.
      See Also:
        Matrix URIs

    - #### replaceQuery

          public abstract UriBuilder replaceQuery(String query)

      Set the URI query string. This method will overwrite any existing query parameters.
      Parameters:
        `query` - the URI query string, may contain URI template parameters. A `null` value will remove all query parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if query cannot be parsed.

    - #### queryParam

          public abstract UriBuilder queryParam(String name,
                              Object... values)

      Append a query parameter to the existing set of query parameters. If multiple values are supplied the parameter will be added once per value.
      Parameters:
        `name` - the query parameter name, may contain URI template parameters.
        `values` - the query parameter value(s), each object will be converted to a `String` using its `toString()` method. Stringified values may contain URI template parameters.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if name or values is `null`.

    - #### replaceQueryParam

          public abstract UriBuilder replaceQueryParam(String name,
                                     Object... values)

      Replace the existing value(s) of a query parameter. If multiple values are supplied the parameter will be added once per value.
      Parameters:
        `name` - the query parameter name, may contain URI template parameters.
        `values` - the query parameter value(s), each object will be converted to a `String` using its `toString()` method. Stringified values may contain URI template parameters. If `values` is empty or `null` then all current values of the parameter are removed.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if name is `null`.

    - #### fragment

          public abstract UriBuilder fragment(String fragment)

      Set the URI fragment.
      Parameters:
        `fragment` - the URI fragment, may contain URI template parameters. A `null` value will remove any existing fragment.
      Returns:
        the updated UriBuilder.

    - #### resolveTemplate

          public abstract UriBuilder resolveTemplate(String name,
                                   Object value)

      Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied value. In case a `null` template name or value is entered a `IllegalArgumentException` is thrown.
      Parameters:
        `name` - name of the URI template.
        `value` - value to be used to resolve the template.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the resolved template name or value is `null`.
      Since:
        2.0

    - #### resolveTemplate

          public abstract UriBuilder resolveTemplate(String name,
                                   Object value,
                                   boolean encodeSlashInPath)

      Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied value. In case a `null` template name or value is entered a `IllegalArgumentException` is thrown.
      Parameters:
        `name` - name of the URI template.
        `value` - value to be used to resolve the template.
        `encodeSlashInPath` - if `true`, the slash (`'/'`) characters in template values will be encoded if the template is placed in the URI path component, otherwise the slash characters will not be encoded in path templates.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the resolved template name or value is `null`.
      Since:
        2.0

    - #### resolveTemplateFromEncoded

          public abstract UriBuilder resolveTemplateFromEncoded(String name,
                                              Object value)

      Resolve a URI template with a given `name` in this `UriBuilder` instance using a supplied encoded value. A template with a matching name will be replaced by the supplied value. Value is converted to `String` using its `toString()` method and is then encoded to match the rules of the URI component to which they pertain. All % characters in the stringified values that are not followed by two hexadecimal numbers will be encoded. In case a `null` template name or encoded value is entered a `IllegalArgumentException` is thrown.
      Parameters:
        `name` - name of the URI template.
        `value` - encoded value to be used to resolve the template.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the resolved template name or encoded value is `null`.
      Since:
        2.0

    - #### resolveTemplates

          public abstract UriBuilder resolveTemplates(Map<String,Object> templateValues)

      Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs. A call to the method with an empty parameter map is ignored.
      Parameters:
        `templateValues` - a map of URI template names and their values.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the name-value map or any of the names or values in the map is `null`.
      Since:
        2.0

    - #### resolveTemplates

          public abstract UriBuilder resolveTemplates(Map<String,Object> templateValues,
                                    boolean encodeSlashInPath)
                                               throws IllegalArgumentException

      Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs. A call to the method with an empty parameter map is ignored.
      Parameters:
        `templateValues` - a map of URI template names and their values.
        `encodeSlashInPath` - if `true`, the slash (`'/'`) characters in template values will be encoded if the template is placed in the URI path component, otherwise the slash characters will not be encoded in path templates.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the name-value map or any of the names or values in the map is `null`.
      Since:
        2.0

    - #### resolveTemplatesFromEncoded

          public abstract UriBuilder resolveTemplatesFromEncoded(Map<String,Object> templateValues)

      Resolve one or more URI templates in this `UriBuilder` instance using supplied name-value pairs. All templates with their name matching one of the keys in the supplied map will be replaced by the value in the supplied map. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All % characters in the stringified values that are not followed by two hexadecimal numbers will be encoded. A call to the method with an empty parameter map is ignored.
      Parameters:
        `templateValues` - a map of URI template names and their values.
      Returns:
        the updated UriBuilder.
      Throws:
        `IllegalArgumentException` - if the name-value map or any of the names or values in the map is `null`.
      Since:
        2.0

    - #### buildFromMap

          public abstract URI buildFromMap(Map<String,?> values)

      Build a URI. Any URI template parameters will be replaced by the value in the supplied map. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All `'%'` characters in the stringified values will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.

      NOTE: By default all `'/'` characters in the stringified values will be encoded in path templates, i.e. the result is identical to invoking `buildFromMap(valueMap, true)`. To override this behavior use `buildFromMap(valueMap, false)` instead.

      Parameters:
        `values` - a map of URI template parameter names and values.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a template parameter value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      See Also:
        `buildFromMap(java.util.Map, boolean)`, `buildFromEncodedMap(java.util.Map)`

    - #### buildFromMap

          public abstract URI buildFromMap(Map<String,?> values,
                         boolean encodeSlashInPath)
                                    throws IllegalArgumentException,
                                           UriBuilderException

      Build a URI. Any URI template parameters will be replaced by the value in the supplied map. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All `'%'` characters in the stringified values will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.

      The `encodeSlashInPath` parameter may be used to override the default encoding of `'/'` characters in the stringified template values in cases when the template is part of the URI path component when using the `buildFromMap(java.util.Map)` method. If the `encodeSlashInPath` parameter is set to `true` (default), the slash (`'/'`) characters in parameter values will be encoded if the template is placed in the URI path component. If set to `false` the default encoding behavior is overridden an slash characters in template values will not be encoded when used to substitute path templates.

      Parameters:
        `values` - a map of URI template parameter names and values.
        `encodeSlashInPath` - if `true`, the slash (`'/'`) characters in parameter values will be encoded if the template is placed in the URI path component, otherwise the slash characters will not be encoded in path templates.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a template parameter value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      See Also:
        `buildFromMap(java.util.Map)`, `buildFromEncodedMap(java.util.Map)`

    - #### buildFromEncodedMap

          public abstract URI buildFromEncodedMap(Map<String,?> values)
                                           throws IllegalArgumentException,
                                                  UriBuilderException

      Build a URI. Any URI template parameters will be replaced by the value in the supplied map. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All % characters in the stringified values that are not followed by two hexadecimal numbers will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.
      Parameters:
        `values` - a map of URI template parameter names and values.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a template parameter value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      Since:
        2.0
      See Also:
        `buildFromMap(java.util.Map)`, `buildFromMap(java.util.Map, boolean)`

    - #### build

          public abstract URI build(Object... values)
                             throws IllegalArgumentException,
                                    UriBuilderException

      Build a URI, using the supplied values in order to replace any URI template parameters. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All '%' characters in the stringified values will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.

      All instances of the same template parameter will be replaced by the same value that corresponds to the position of the first instance of the template parameter. e.g. the template "{a}/{b}/{a}" with values {"x", "y", "z"} will result in the the URI "x/y/x", not "x/y/z".

      NOTE: By default all `'/'` characters in the stringified values will be encoded in path templates, i.e. the result is identical to invoking `build(Object[], boolean)` build(values, true)}. To override this behavior use `build(values, false)` instead.

      Parameters:
        `values` - a list of URI template parameter values.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      See Also:
        `build(Object[], boolean)`, `buildFromEncoded(Object...)`

    - #### build

          public abstract URI build(Object[] values,
                  boolean encodeSlashInPath)
                             throws IllegalArgumentException,
                                    UriBuilderException

      Build a URI, using the supplied values in order to replace any URI template parameters. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All '%' characters in the stringified values will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.

      All instances of the same template parameter will be replaced by the same value that corresponds to the position of the first instance of the template parameter. e.g. the template "{a}/{b}/{a}" with values {"x", "y", "z"} will result in the the URI "x/y/x", not "x/y/z".

      The `encodeSlashInPath` parameter may be used to override the default encoding of `'/'` characters in the stringified template values in cases when the template is part of the URI path component when using the `build(Object[])` method. If the `encodeSlashInPath` parameter is set to `true` (default), the slash (`'/'`) characters in parameter values will be encoded if the template is placed in the URI path component. If set to `false` the default encoding behavior is overridden an slash characters in template values will not be encoded when used to substitute path templates.

      Parameters:
        `values` - a list of URI template parameter values.
        `encodeSlashInPath` - if `true`, the slash (`'/'`) characters in parameter values will be encoded if the template is placed in the URI path component, otherwise the slash characters will not be encoded in path templates.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      Since:
        2.0
      See Also:
        `build(Object[])`, `buildFromEncoded(Object...)`

    - #### buildFromEncoded

          public abstract URI buildFromEncoded(Object... values)
                                        throws IllegalArgumentException,
                                               UriBuilderException

      Build a URI. Any URI templates parameters will be replaced with the supplied values in order. Values are converted to `String` using their `toString()` method and are then encoded to match the rules of the URI component to which they pertain. All % characters in the stringified values that are not followed by two hexadecimal numbers will be encoded. The state of the builder is unaffected; this method may be called multiple times on the same builder instance.

      All instances of the same template parameter will be replaced by the same value that corresponds to the position of the first instance of the template parameter. e.g. the template "{a}/{b}/{a}" with values {"x", "y", "z"} will result in the the URI "x/y/x", not "x/y/z".

      Parameters:
        `values` - a list of URI template parameter values.
      Returns:
        the URI built from the UriBuilder.
      Throws:
        `IllegalArgumentException` - if there are any URI template parameters without a supplied value, or if a value is `null`.
        `UriBuilderException` - if a URI cannot be constructed based on the current state of the builder.
      See Also:
        `build(Object[])`, `build(Object[], boolean)`

    - #### toTemplate

          public abstract String toTemplate()

      Get the URI template string represented by this URI builder.
      Returns:
        the URI template string for this URI builder.
      Since:
        2.0

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.